﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Diagnostics;
using System.IO;
using System.Text.RegularExpressions;

namespace RemoteShellService
{
    // NOTE: If you change the class name "ShellService" here, you must also update the reference to "ShellService" in App.config.
    public class ShellService : IShellService
    {
        static ServiceHost host;
        public static void Start()
        {
            host = new ServiceHost(typeof(ShellService));
            host.Open();
        }

        public static void Stop()
        {
            host.Close();
        }

        #region IShellService Members

        public void Execute(string command, ref string workingDirectory, ref string result)
        {
            try
            {
                ProcessStartInfo startInfo = new ProcessStartInfo("CMD.exe");

                Process p = new Process();
                startInfo.RedirectStandardInput = true;
                startInfo.UseShellExecute = false;
                startInfo.RedirectStandardOutput = true;
                startInfo.RedirectStandardError = true;
                startInfo.CreateNoWindow = true;

                if (workingDirectory.EndsWith(">"))
                    workingDirectory = workingDirectory.Replace(">", "");
                Directory.SetCurrentDirectory(workingDirectory);
                p = Process.Start(startInfo);
                p.StandardInput.WriteLine(command);
                p.StandardInput.WriteLine("EXIT");
                result = p.StandardOutput.ReadToEnd();

                var match = Regex.Match(result, "\r\n(?<WorkingDirectory>.+)EXIT");
                if (match.Success)
                {
                    result = result.Substring(0, match.Index);
                    workingDirectory = match.Groups["WorkingDirectory"].Value;
                }

                result += p.StandardError.ReadToEnd();
            }
            catch (Exception ex)
            {
                result = ex.Message;
            }
        }

        #endregion
    }
}
